
local function buttonhook(tile, buttonid, statevar)
  hook(tile).onStand = function (x, y, l, player)
    if world.state[buttonid] then return end
    world.state[statevar] = not world.state[statevar]
    world.state[buttonid] = player.id
  end
end
local function buttoncheck(tile, buttonid, statevar)
  local b = map:find(tile)[1]
  local s = world.state[buttonid]
  if s and not world.players[s].actor:intersectsField(b.x, b.y) then
    world.state[buttonid] = nil
    world.state[statevar] = not world.state[statevar]
    world:updateState()
  end
end

hook'specials/3'.onActivate = function (x, y, l, player)
  player:warp('maps/level1b.tmx', 55, 52)
end

hook'specials/4'.onActivate = function (x, y, l, player)
  player:warp('maps/level2.tmx', 22, 24)
end

hook'specials/5'.onActivate = function (x, y, l, player)
  player:warp('maps/level0.tmx', 56, 16)
end

hook'specials/6'.onActivate = function (x, y, l, player)
  player:warp('maps/level2.tmx', 18, 78)
end

buttonhook('floor_buttons/1', 'level1_green_standing', 'button_green')

function map.updateState()
  for i,pos in ipairs(map:find('specials/3')) do
    map:setField(i == 2 and 'stairs_cave/3' or 'stairs_cave/4', 2, pos) end
  map:setField('stairs_cave/6', 2, map:find('specials/4')[1])
  for i,pos in ipairs(map:find('specials/5')) do
    map:setField(i == 2 and 'stairs_cave/2' or 'stairs_cave/4', 2, pos) end
  map:setField('stairs_cave/6', 2, map:find('specials/6')[1])
  map:setField(world.state.button_green and 'doors/0' or 'doors/4', 2, map:find('doors/0')[1])
  map:setField(world.state.level1_green_standing and 'floor_buttons/6' or 'floor_buttons/1', 2, map:find('floor_buttons/1')[1])
end

local oldupdate = map.update
function map:update()
  oldupdate(self)
  buttoncheck('floor_buttons/1', 'level1_green_standing', 'button_green')
end

map:updateState()
local d = map:find('doors/0')[1]; map.animTimes[d.i][d.y][d.x] = -100
map.doorcolor[d.x] = { 0.5, 1, 0.5 }

local function spawnuj_pavuka_lahkeho(x,y)
 map:addEnemy(x, y, { size = 0.8, pursuitSpeed = 1, stopPursuitDistance = 10, health = 1 }, { base = 'spider_eyes/', frames = 2, delay = 3 })
end
local function spawnuj_pavuka_stredneho(x,y)
 map:addEnemy(x, y, { size = 0.8, pursuitSpeed = 3, stopPursuitDistance = 8, health = 1 }, { base = 'spider_eyes/', frames = 2, delay = 3 })
end
local function spawnuj_pavuka_tazkeho(x,y)
 map:addEnemy(x, y, { size = 0.76, pursuitSpeed = 3.5, stopPursuitDistance = 12, health = 2, walkTimeMin = 1, walkTimeMax = 1 }, { base = 'spider_blue/', frames = 4, delay = 2 })
end
local function spawnuj_motyla_modreho(x,y)
 map:addEnemy(x, y, { size = 0.76, pursuitSpeed = 2.8, stopPursuitDistance = 9, health = 1 }, { base = 'butterfly/', frames = 2, delay = 3 })
end
local function spawnuj_motyla_cerveneho(x,y)
 map:addEnemy(x, y, { size = 0.76, pursuitSpeed = 2.8, stopPursuitDistance = 9, health = 2 }, { base = 'butterfly_red/', frames = 2, delay = 3 })
end
  spawnuj_pavuka_lahkeho(75, 43)
  spawnuj_pavuka_lahkeho(57, 38)
  spawnuj_pavuka_lahkeho(59, 37)
  spawnuj_pavuka_lahkeho(33, 21)
  spawnuj_pavuka_stredneho(77, 20)
  spawnuj_pavuka_stredneho(77, 19)
  spawnuj_pavuka_tazkeho(33, 54)
  spawnuj_motyla_modreho(19, 40)
  spawnuj_motyla_modreho(19, 41)
  spawnuj_motyla_modreho(19, 42)
  spawnuj_motyla_cerveneho(56, 58)
  spawnuj_motyla_cerveneho(56, 59)
  spawnuj_motyla_cerveneho(56, 60)
  spawnuj_motyla_cerveneho(56, 61)
  spawnuj_motyla_cerveneho(79, 70)
  spawnuj_motyla_cerveneho(79, 71)
  spawnuj_motyla_cerveneho(79, 72)
  spawnuj_motyla_cerveneho(79, 73)
  spawnuj_motyla_cerveneho(79, 74)
  spawnuj_motyla_cerveneho(79, 75)
  spawnuj_motyla_cerveneho(79, 76)
  spawnuj_motyla_cerveneho(79, 77)
