
local function buttonhook(tile, buttonid, statevar)
  hook(tile).onStand = function (x, y, l, player)
    if world.state[buttonid] then return end
    world.state[statevar] = not world.state[statevar]
    world.state[buttonid] = player.id
  end
end
local function buttoncheck(tile, buttonid, statevar)
  local b = map:find(tile)[1]
  local s = world.state[buttonid]
  if s and not world.players[s].actor:intersectsField(b.x, b.y) then
    world.state[buttonid] = nil
    world.state[statevar] = not world.state[statevar]
    world:updateState()
  end
end

hook'specials/1'.onActivate = function (x, y, l, player)
  player:warp('maps/level2.tmx', 63, 33)
end
hook'specials/2'.onActivate = function (x, y, l, player)
  player:warp('maps/level2.tmx', 78, 50)
end
hook'specials/3'.onActivate = function (x, y, l, player)
  player:warp('maps/level4.tmx', 43, 33)
end
hook'specials/4'.onActivate = function (x, y, l, player)
  player:warp('maps/level4.tmx', 67, 54)
end

buttonhook('floor_buttons/0', 'level3_red_standing', 'button_red')
buttonhook('floor_buttons/3', 'level3_purple_standing', 'button_purple')
buttonhook('floor_buttons/4', 'level3_orange_standing', 'button_orange')

function map.updateState()
  -- stairs
  for i,pos in ipairs(map:find('specials/1')) do
    map:setField(i == 2 and 'stairs_cave/4' or 'stairs_cave/1', 2, pos) end
  for i,pos in ipairs(map:find('specials/2')) do
    map:setField(i == 2 and 'stairs_cave/4' or 'stairs_cave/0', 2, pos) end
  map:setField('stairs_cave/6', 2, map:find('specials/3')[1])
  map:setField('stairs_cave/6', 2, map:find('specials/4')[1])
  -- buttons
  map:setField(world.state.level3_red_standing and 'floor_buttons/5' or 'floor_buttons/0', map:find('floor_buttons/0')[1])
  map:setField(world.state.level3_purple_standing and 'floor_buttons/8' or 'floor_buttons/3', map:find('floor_buttons/3')[1])
  map:setField(world.state.level3_orange_standing and 'floor_buttons/9' or 'floor_buttons/4', map:find('floor_buttons/4')[1])
  -- doors
  map:setField(world.state.button_green and 'doors/0' or 'doors/4', map:find('doors/0')[1])
  map:setField(world.state.button_purple and 'doors/8' or 'doors/12', map:find('doors/8')[1])
end

local oldupdate = map.update
function map:update()
  oldupdate(self)
  buttoncheck('floor_buttons/0', 'level3_red_standing', 'button_red')
  buttoncheck('floor_buttons/3', 'level3_purple_standing', 'button_purple')
  buttoncheck('floor_buttons/4', 'level3_orange_standing', 'button_orange')
end

map:updateState()
local d = map:find('doors/0')[1]; map.animTimes[d.i][d.y][d.x] = -100
map.doorcolor[d.x] = { 0.5, 1, 0.5 }
local d = map:find('doors/8')[1]; map.animTimes[d.i][d.y][d.x] = -100
map.doorcolor[d.x] = { 1, 0.5, 1 }

local function spawnuj_motyla_modreho(x,y)
 map:addEnemy(x, y, { size = 0.76, pursuitSpeed = 2.8, stopPursuitDistance = 9, health = 1 }, { base = 'butterfly/', frames = 2, delay = 3 })
end
local function spawnuj_motyla_cerveneho(x,y)
 map:addEnemy(x, y, { size = 0.76, pursuitSpeed = 2.8, stopPursuitDistance = 9, health = 2 }, { base = 'butterfly_red/', frames = 2, delay = 3 })
end
local function spawnuj_pavuka_lahkeho(x,y)
 map:addEnemy(x, y, { size = 0.8, pursuitSpeed = 1, stopPursuitDistance = 10, health = 1 }, { base = 'spider_eyes/', frames = 2, delay = 3 })
end
local function spawnuj_pavuka_stredneho(x,y)
 map:addEnemy(x, y, { size = 0.8, pursuitSpeed = 3, stopPursuitDistance = 8, health = 1 }, { base = 'spider_cyan/', frames = 4, delay = 2 })
end

  spawnuj_motyla_cerveneho(28, 64)
  spawnuj_motyla_cerveneho(28, 65)
  spawnuj_motyla_cerveneho(28, 66)
  spawnuj_motyla_cerveneho(37, 35)
  spawnuj_motyla_cerveneho(38, 35)
  spawnuj_motyla_modreho(22, 64)
  spawnuj_motyla_modreho(22, 65)
  spawnuj_motyla_modreho(22, 66)
  spawnuj_motyla_modreho(22, 67)
  spawnuj_motyla_modreho(14, 50)
  spawnuj_motyla_modreho(15, 50)
  spawnuj_motyla_modreho(16, 50)
  spawnuj_motyla_modreho(17, 50)
  spawnuj_motyla_modreho(41, 79)
  spawnuj_motyla_modreho(41, 80)
  spawnuj_motyla_modreho(41, 81)
  spawnuj_pavuka_lahkeho(7, 78)
  spawnuj_pavuka_lahkeho(8, 78)
  spawnuj_pavuka_lahkeho(9, 78)
  spawnuj_pavuka_lahkeho(10, 78)
  spawnuj_pavuka_lahkeho(80, 46)
  spawnuj_pavuka_lahkeho(80, 47)
  spawnuj_pavuka_lahkeho(80, 48)
  spawnuj_pavuka_lahkeho(80, 49)
  spawnuj_pavuka_stredneho(17, 19)
  spawnuj_pavuka_stredneho(18, 19)
  spawnuj_pavuka_stredneho(19, 19)
  spawnuj_pavuka_stredneho(47, 20)
  spawnuj_pavuka_stredneho(47, 21)
  spawnuj_pavuka_stredneho(47, 22)
  spawnuj_pavuka_stredneho(73, 18)
  spawnuj_pavuka_stredneho(77, 25)
