
local function buttonhook(tile, buttonid, statevar)
  hook(tile).onStand = function (x, y, l, player)
    if world.state[buttonid] then return end
    world.state[statevar] = not world.state[statevar]
    world.state[buttonid] = player.id
  end
end
local function buttoncheck(tile, buttonid, statevar)
  local b = map:find(tile)[1]
  local s = world.state[buttonid]
  if s and not world.players[s].actor:intersectsField(b.x, b.y) then
    world.state[buttonid] = nil
    world.state[statevar] = not world.state[statevar]
    world:updateState()
  end
end

hook'specials/2'.onActivate = function (x, y, l, player)
  player:warp('maps/level3.tmx', 58, 30)
end

hook'specials/3'.onActivate = function (x, y, l, player)
  player:warp('maps/level3.tmx', 80, 53)
end

hook'stairs_cave/6'.onActivate = function (x, y, l, player)
  player:warp('maps/level5.tmx', 79, 20)
end

buttonhook('floor_buttons/2', 'level4_blue_standing', 'button_blue')

function map.updateState()
  for i,pos in ipairs(map:find('specials/1')) do
    map:setField(world.state.button_blue and 'ice/0' or 'cave/0', pos) end
  for i,pos in ipairs(map:find('specials/2')) do
    map:setField(i == 2 and 'stairs_cave/3' or 'stairs_cave/4', 2, pos) end
  for i,pos in ipairs(map:find('specials/3')) do
    map:setField(i == 2 and 'stairs_cave/2' or 'stairs_cave/4', 2, pos) end
  map:setField(world.state.button_green and 'doors/4' or 'doors/0', 2, map:find('doors/0')[1])
  map:setField(world.state.level4_blue_standing and 'floor_buttons/7' or 'floor_buttons/2', 2, map:find('floor_buttons/2')[1])
end

local oldupdate = map.update
function map:update()
  oldupdate(self)
  buttoncheck('floor_buttons/2', 'level4_blue_standing', 'button_blue')
end

map:updateState()
local d = map:find('doors/0')[1]; map.animTimes[d.i][d.y][d.x] = -100
map.doorcolor[d.x] = { 0.5, 1, 0.5 }

local function spawnuj_hlavu(x,y)
 map:addEnemy(x, y, { size = 0.8, pursuitSpeed = 0.5, speed = 0.5, stopPursuitDistance = 12, health = 7, waitTimeMin = 10, waitTimeMax = 15 }, { base = 'olmec_head_alive/', frames = 4, delay = 2 })
end

  spawnuj_hlavu(64, 53)
  spawnuj_hlavu(64, 54)
  spawnuj_hlavu(64, 55)
  spawnuj_hlavu(64, 56)
  spawnuj_hlavu(36, 27)
  spawnuj_hlavu(37, 27)
  spawnuj_hlavu(38, 27)
  spawnuj_hlavu(39, 27)
  spawnuj_hlavu(40, 27)
  spawnuj_hlavu(41, 27)
  spawnuj_hlavu(42, 27)
  spawnuj_hlavu(43, 27)
  spawnuj_hlavu(44, 27)
  spawnuj_hlavu(44, 39)
  spawnuj_hlavu(45, 39)
  spawnuj_hlavu(19, 68)
  spawnuj_hlavu(19, 69)
