
pcall(require, 'userrc')

require 'Object'
Object.instantiate = Object.subclass
function Class(o) return Object:subclass(o) end

require 'extlib'
require 'SDL'
require 'gl'

USERRC = FS.loadText('userrc.lua') or ''
collectgarbage'collect'

SDL.Init(SDL.INIT_VIDEO + SDL.INIT_AUDIO + SDL.INIT_TIMER)

_SOUND = pcall(SDL.OpenAudio, 44100, SDL.AUDIO_S16SYS, 2, 4096)

WIDTH = WIDTH or 800
HEIGHT = HEIGHT or 600
if SOUND == nil then SOUND = true end
if FULLSCREEN == nil then FULLSCREEN = true end
LASTGAME = LASTGAME or 1

math.randomseed(os.time())

SDL.GL_SetAttribute(SDL.GL_DOUBLEBUFFER, 1)
SDL.GL_SetAttribute(SDL.GL_STENCIL_SIZE, 1)
SDL.GL_SetAttribute(SDL.GL_ALPHA_SIZE, 1)
SDL.SetVideoMode(WIDTH, HEIGHT, FULLSCREEN)
gl.Viewport(0, 0, WIDTH, HEIGHT)

SDL.EnableKeyRepeat(250, 100)   -- used in yarivan.Menu
SDL.ShowCursor(not FULLSCREEN)
SDL.WM_SetCaption("Yarivan", "Yarivan")

gl.ClearColor(0, 0, 0, 1)
gl.Hint(GL.PERSPECTIVE_CORRECTION_HINT, GL.NICEST)
gl.Enable(GL.TEXTURE_2D)
gl.BlendFunc(GL.SRC_ALPHA, GL.ONE_MINUS_SRC_ALPHA); gl.Enable(GL.BLEND)

gl.MatrixMode(GL.PROJECTION); gl.LoadIdentity()
gl.Ortho(0, WIDTH, 0, HEIGHT, 1, -1)
gl.MatrixMode(GL.MODELVIEW); gl.LoadIdentity()

if arg[1] == 'map' then
  require 'yarivan.WindowManager'
  require 'yarivan.GameWorld'
  require 'MainLoop'
  local m, x, y = assert(arg[2]), tonumber(arg[3] or 0), tonumber(arg[4] or 0)
  local loop = MainLoop:new{}
  loop.root:addChild('wm', yarivan.WindowManager:new{ parent = loop.root })
  loop.root.wm:addChild('world', yarivan.GameWorld:new{ parent = loop.root.wm })
  loop.root.wm.world.players[1]:setLocation(m, x, y)
  loop.root.wm.world.players[2]:setLocation(m, x, y)
  loop:run()
  return
end

-- simple loading screen
require 'Fonts'
local s = "[yarivan]"
local f = Fonts['fonts/ANTIQUEN.ttf:16']
gl.PushMatrix()
gl.Translate(WIDTH/2-f:prepare(s)/2, HEIGHT/2, 0); f:print(s)
gl.PopMatrix()
SDL.GL_SwapBuffers()

require 'MainLoop'
require 'yarivan.MainMenu'
require 'yarivan.MapLoader'
yarivan.MapLoader.load('maps/level1.tmx')   -- preload most tilesets
MainLoop:new{ root = yarivan.MainMenu.makeMainMenu() }:run()

