
local _G = _G
local SDL = SDL

module(...)

function send(ev, target)
  if target then ev.target = target end
  if not ev.target then
    _G.notice("warning - event target is nil; discarding event"); return false end
  local n, o, parents = 0, ev.target, {}
  while o do n=n+1; parents[n] = o; o = o.parent end
  for i = n, 1, -1 do if parents[i]:eventFilter(ev) then return true end end
  for i = 1, n do if parents[i]:event(ev) then return true end end
  return false
end

-- the value are constructed so that Event.key[sym] is true when an
-- :update() function should handle a key
JUST_PRESSED = 1   -- just pressed (needed for JUST_RELEASED to work)
JUST_RELEASED = 2   -- already released, but it wasn't handled by :update() yet
PRESSED = 3   -- can be released
OVERRIDDEN = false   -- already handled by Event.send, ignore it in :update()
RELEASED = nil
key = {}
function key_update()
  for k, v in _G.pairs(key) do
    if v == JUST_PRESSED then key[k] = PRESSED end
    if v == JUST_RELEASED then key[k] = RELEASED end end
end

-- cur_x,y are the most up-to-date information for the current display frame
-- TODO: can't they be merged into x,y?
mouse = { x = 0, y = 0, cur_x = 0, cur_y = 0 }

active = { [SDL.APPINPUTFOCUS] = true, [SDL.APPMOUSEFOCUS] = true, [SDL.APPACTIVE] = true }
