
local gl = require 'gl'
local Fonts = require 'Fonts'
local Node = require 'Node'
local Selection = require 'Selection'

module(...)

local Label = _M
Node.Moving:subclass(Label)

Label.fontId = nil
Label.floorPosition = true
Label.text = ''
Label.color = { 0, 0, 0 }
Label.centered = false
Label.underline = nil
Label.z = 0

function Label:displayContent()
  local len = Fonts[self.fontId]:prepare(self.text)
  if self.centered then gl.Translate(-len/2, 0, 0) end
  if Selection.active then
    Fonts.DrawBoundingBox(Fonts[self.fontId], len)
  else
    if self.color then gl.Color(self.color) end
    Fonts[self.fontId]:print(self.text, self.underline)
  end
  Node.Moving.displayContent(self)
end

