
local getmetatable, setmetatable, type, rawset =
  getmetatable, setmetatable, type, rawset
local sub = string.sub

module(...)

local Object = _M
_M, _NAME, _PACKAGE = nil

local function index(o, k)
  local ks = (type(k) == 'string')
  if not (ks and sub(k, 1, 2) == '__') then
    local mm = o[ks and '__get_'..k or '__get']
    if mm then return mm(o, k) end
  end
  return getmetatable(o).class[k]
end

local function newindex(o, k, v)
  (o[type(k) == 'string' and '__set_'..k or '__set'] or rawset)(o, k, v)
end

function Object:subclass(o)
  o = o or {}
  o.__index = o
  o.__mt = { __index = index, __newindex = newindex, class = o }
  return setmetatable(o, self)
end

function Object:initialize()
end

function Object:new(o, ...)
  o = setmetatable(o or {}, self.__mt)
  return o:initialize(...) or o
end

-- prepare Object.__mt (and make Object's parent nil)
Object.subclass(nil, Object)

