
local error = error

module(...)

-- see also http://lua-users.org/wiki/LuaXml

function parseargs(s, l)
  local arg = {xml=l}
  s:gsub("(%w+)=([\"'])(.-)%2", function (w, _, a) arg[w] = a end)
  return arg
end
    
function parse(s)
  local stack = {}
  local top = {}
  stack[#stack+1] = top
  local ni,c,label,xarg, empty
  local i, j = 1, 1
  while true do
    ni,j,c,label,xarg, empty = s:find("<(%/?)([%w:]+)(.-)(%/?)>", i)
    if not ni then break end
    local text = s:sub(i, ni-1)
    if not text:find("^%s*$") then
      top[#top+1] = text
    end
    if empty == "/" then  -- empty element tag
      top[#top+1] = parseargs(xarg, label)
    elseif c == "" then   -- start tag
      top = parseargs(xarg, label)
      stack[#stack+1] = top   -- new level
    else  -- end tag
      local toclose = stack[#stack]; stack[#stack] = nil   -- remove top
      top = stack[#stack]
      if #stack < 1 then
        error("nothing to close with "..label)
      end
      if toclose.xml ~= label then
        error("trying to close "..toclose.xml.." with "..label)
      end
      top[#top+1] = toclose
    end
    i = j+1
  end
  local text = s:sub(i)
  if not text:find("^%s*$") then
    stack[#stack][#stack[#stack]+1] = text
  end
  if #stack > 1 then
    error("unclosed "..stack[stack.n].xml)
  end
  return stack[1]
end


