
local _G = _G
local SDL, zlib, string = SDL, zlib, string
local assert = assert

module(...)

function compress(source)
  local sourceLen = #source
  local destLen = zlib.compressBound(sourceLen)
  local destBuf = SDL.RWFromNewMem(destLen)
  destLen = zlib.compress(destBuf:baseptr(), destLen, source, sourceLen)
  -- last six bytes contain an ULT footer with uncompressed length
  return assert(destBuf:read(destLen)) ..
    string.pack('<2sC', 'Z\014', sourceLen)
end

function uncompress(dest)
  local header, sourceLen = string.unpack(dest:sub(-6, -1), '<2sC')
  assert(header == 'Z\014', "malformed data")
  local sourceBuf = SDL.RWFromNewMem(sourceLen)
  sourceLen = zlib.uncompress(sourceBuf:baseptr(), sourceLen, dest, #dest)
  return assert(sourceBuf:read(sourceLen))
end
