
require 'extlib'
require 'globalgl'
require 'Event'
require 'MainLoop'

function toggle(enabling)
  return enabling and glEnable or glDisable
end

WIDTH = 1024
HEIGHT = 768
FULLSCREEN = false

GameLoop = MainLoop:instantiate()

function GameLoop:initialize()
  MainLoop.initialize(self)
  self.scroll_x, self.scroll_y = 0, 0, 0, 0
  self.my_x, self.my_y = 100, 100
  self.speed_x, self.speed_y = 0, 0
end

function GameLoop:key(ev)
  if not ev.down then return end
  if ev.sym == SDL.K_ESCAPE then self:quit() end
  if ev.sym == SDL.K_F1 then pcall(SDL.WM_ToggleFullScreen); return end
  -- handleKeypress(ev.sym)
end

local function changeval(val, change, min, max)
  if change > 0 then
    return val < max and val+change or val
  else
    return val > min and val+change or val
  end
end
function GameLoop:update()
  self.my_x = self.my_x + self.speed_x
  self.my_y = self.my_y + self.speed_y
  
  if self.speed_y == 0 then
    self.speed_x = changeval(self.speed_x, Event.key[SDL.K_RIGHT] and 1 or -1, 0, 5)
    self.speed_x = changeval(self.speed_x, Event.key[SDL.K_LEFT] and -1 or 1, -5, 0)
    if Event.key[SDL.K_UP] then self.speed_y = 8 end
  end
  
  self.speed_y = self.speed_y - 0.4   -- gravity
  
  if not self:canBePresent(self.my_x + self.speed_x, self.my_y) then self.speed_x = 0 end
  if not self:canBePresent(self.my_x, self.my_y + self.speed_y) then self.speed_y = 0 end
  if not self:canBePresent(self.my_x + self.speed_x, self.my_y + self.speed_y) then self.speed_x, self.speed_y = 0, 0 end
end

function GameLoop:canBePresent(x, y)
  if x < 50 or x > 200 then return false end
  if y < 50 or y > 200 then return false end
  return true
end

function GameLoop:display()
  glClear(GL_COLOR_BUFFER_BIT)
  glBindTexture(GL_TEXTURE_2D, 0)
  
  glLoadIdentity()
  glColor(1, 1, 0)
  glBegin(GL_QUADS)
    glVertex(50-16, 50-16)
    glVertex(200+16, 50-16)
    glVertex(200+16, 200+16)
    glVertex(50-16, 200+16)
  glEnd()
  
  glLoadIdentity()
  glTranslate(self.my_x + self.frameFraction*self.speed_x, self.my_y + self.frameFraction*self.speed_y, 0)
  glColor(1, 0, 0)
  glBegin(GL_QUADS)
    glVertex(-16, -16)
    glVertex(16, -16)
    glVertex(16, 16)
    glVertex(-16, 16)
  glEnd()
end

SDL.GL_SetAttribute(SDL.GL_DOUBLEBUFFER, 1)
SDL.GL_SetAttribute(SDL.GL_ALPHA_SIZE, 1)
SDL.SetVideoMode(WIDTH, HEIGHT, FULLSCREEN)
glViewport(0, 0, WIDTH, HEIGHT)

glClearColor(1, 1, 1, 1)

glMatrixMode(GL_PROJECTION)
glLoadIdentity()
--gluPerspective(45.0, WIDTH/HEIGHT, 0.1, 100.0)
glOrtho(0, WIDTH, 0, HEIGHT, -100, 100)

glMatrixMode(GL_MODELVIEW)
glLoadIdentity()

glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST)
glEnable(GL_TEXTURE_2D)
glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA)
glEnable(GL_BLEND)

GameLoop:new():run()
