
require 'test.nehe.nehelib'

light = false
xrot, yrot, xspeed, yspeed = 0, 0, 0, 0
zpos = -5
filter = 1
my_textures = { }

function drawGLScene(interpolation)
  glClear(GL_COLOR_BUFFER_BIT + GL_DEPTH_BUFFER_BIT)
  
  glLoadIdentity()
  glTranslate(0, 0, zpos)
  glRotate(xrot + (interpolation * xspeed), 1, 0, 0)
  glRotate(yrot + (interpolation * yspeed), 0, 1, 0)
  
  glBindTexture(GL_TEXTURE_2D, my_textures[filter])
  
  glBegin(GL_QUADS)
    glNormal(0, 1, 0)
    glTexCoord(1, 1); glVertex( 1,  1, -1)
    glTexCoord(0, 1); glVertex(-1,  1, -1)
    glTexCoord(0, 0); glVertex(-1,  1,  1)
    glTexCoord(1, 0); glVertex( 1,  1,  1)
    
    glNormal(0, -1, 0)
    glTexCoord(0, 0); glVertex( 1, -1,  1)
    glTexCoord(1, 0); glVertex(-1, -1,  1)
    glTexCoord(1, 1); glVertex(-1, -1, -1)
    glTexCoord(0, 1); glVertex( 1, -1, -1)
    
    glNormal(0, 0, 1)
    glTexCoord(1, 1); glVertex( 1,  1,  1)
    glTexCoord(0, 1); glVertex(-1,  1,  1)
    glTexCoord(0, 0); glVertex(-1, -1,  1)
    glTexCoord(1, 0); glVertex( 1, -1,  1)
    
    glNormal(0, 0, -1)
    glTexCoord(1, 1); glVertex(-1,  1, -1)
    glTexCoord(0, 1); glVertex( 1,  1, -1)
    glTexCoord(0, 0); glVertex( 1, -1, -1)
    glTexCoord(1, 0); glVertex(-1, -1, -1)
    
    glNormal(-1, 0, 0)
    glTexCoord(1, 1); glVertex(-1,  1,  1)
    glTexCoord(0, 1); glVertex(-1,  1, -1)
    glTexCoord(0, 0); glVertex(-1, -1, -1)
    glTexCoord(1, 0); glVertex(-1, -1,  1)
    
    glNormal(1, 0, 0)
    glTexCoord(1, 1); glVertex( 1,  1, -1)
    glTexCoord(0, 1); glVertex( 1,  1,  1)
    glTexCoord(0, 0); glVertex( 1, -1,  1)
    glTexCoord(1, 0); glVertex( 1, -1, -1)
  glEnd()
end

function computeFrame()
  xrot = xrot + xspeed
  yrot = yrot + yspeed
  
  if Event.key[SDL.K_PAGEUP] then zpos = zpos - 0.02 end
  if Event.key[SDL.K_PAGEDOWN] then zpos = zpos + 0.02 end
  if Event.key[SDL.K_UP] then xspeed = xspeed - 0.3 end
  if Event.key[SDL.K_DOWN] then xspeed = xspeed + 0.3 end
  if Event.key[SDL.K_LEFT] then yspeed = yspeed - 0.3 end
  if Event.key[SDL.K_RIGHT] then yspeed = yspeed + 0.3 end
end

function handleKeypress(sym)
  if sym == SDL.K_f then filter = (filter == 3 and 2 or filter+1) end
  if sym == SDL.K_l then light = not light; toggle(light)(GL_LIGHTING) end
end

local function _f(a,b)
  glTexParameter(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,a)
  glTexParameter(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,b)
end

initScreen()

glShadeModel(GL_SMOOTH)
glClearColor(0, 0, 0, 0)
glClearDepth(1)
glEnable(GL_DEPTH_TEST)
glDepthFunc(GL_LEQUAL)
glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST)

glLight(GL_LIGHT1, GL_AMBIENT, 0.5, 0.5, 0.5, 1)
glLight(GL_LIGHT1, GL_DIFFUSE, 1, 1, 1, 1)
glLight(GL_LIGHT1, GL_POSITION, 0, 0, 2, 1)
glEnable(GL_LIGHT1)

glEnable(GL_TEXTURE_2D)
my_textures = { glGenTextures(3) }
local img = loadImage('test/nehe/crate.bmp')
glBindTexture(GL_TEXTURE_2D, my_textures[1])
_f(GL_NEAREST, GL_NEAREST); img:glTexImage2D()
glBindTexture(GL_TEXTURE_2D, my_textures[2])
_f(GL_LINEAR, GL_LINEAR); img:glTexImage2D()
glBindTexture(GL_TEXTURE_2D, my_textures[3])
_f(GL_LINEAR, GL_LINEAR_MIPMAP_NEAREST); img:glTexImage2D(true)

NeheLoop:new():run()
