
require 'test.nehe.nehelib'

twinkle = false
splotches = true
num_stars = 50
stars = { }
zoom = -15
tilt = 90
spin = 0
my_texture = nil

function drawGLScene(interpolation)
  glClear(GL_COLOR_BUFFER_BIT + GL_DEPTH_BUFFER_BIT)
  
  glBindTexture(GL_TEXTURE_2D, my_texture)
  
  for i = 1, num_stars do
    glLoadIdentity()
    
    glPushName(i)  -- picking test
    
    glTranslate(0, 0, zoom)
    glRotate(tilt, 1, 0, 0)
    glRotate(stars[i].angle + (interpolation * i/num_stars), 0, 1, 0)
    glTranslate(stars[i].dist, 0, 0)
    glRotate(-stars[i].angle, 0, 1, 0)
    glRotate(-tilt, 1, 0, 0)
    
    if twinkle then
      glColor(stars[num_stars-i+1].r, stars[num_stars-i+1].g, stars[num_stars-i+1].b, 1)
      glBegin(GL_QUADS)
        glTexCoord(0, 0); glVertex(-1, -1, 0)
        glTexCoord(1, 0); glVertex( 1, -1, 0)
        glTexCoord(1, 1); glVertex( 1,  1, 0)
        glTexCoord(0, 1); glVertex(-1,  1, 0)
      glEnd()
    end
    
    glRotate(spin + (interpolation * 0.01), 0, 0, 1)
    glColor(stars[i].r, stars[i].g, stars[i].b, 1)
    glBegin(GL_QUADS)
      glTexCoord(0, 0); glVertex(-1, -1, 0)
      glTexCoord(1, 0); glVertex( 1, -1, 0)
      glTexCoord(1, 1); glVertex( 1,  1, 0)
      glTexCoord(0, 1); glVertex(-1,  1, 0)
    glEnd()
    
    glPopName()
  end
end

function computeFrame()
  spin = spin + 0.01
  for i = 1, num_stars do
    stars[i].angle = stars[i].angle + i/num_stars
    -- I like it more when stars[i].dist doesn't change.
--    stars[i].dist = stars[i].dist - 0.01
    if stars[i].dist < 0 then
      stars[i].dist = stars[i].dist + 5
      stars[i].r = math.random()
      stars[i].g = math.random()
      stars[i].b = math.random()
    end
  end
  
  if Event.key[SDL.K_PAGEUP] then zoom = zoom - 0.2 end
  if Event.key[SDL.K_PAGEDOWN] then zoom = zoom + 0.2 end
  if Event.key[SDL.K_UP] then tilt = tilt - 0.5 end
  if Event.key[SDL.K_DOWN] then tilt = tilt + 0.5 end
end

function handleKeypress(sym)
  if sym == SDL.K_t then twinkle = not twinkle end
  if sym == SDL.K_s then
    -- the original NeHe implementation uses a messed up blendFunc
    -- pressing 'S' in this program toggles a better-looking version
    splotches = not splotches
    if splotches then glBlendFunc(GL_SRC_ALPHA, GL_ONE) else
      glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR) end
  end
end

initScreen()

glShadeModel(GL_SMOOTH)
glClearColor(0, 0, 0, 0)
glClearDepth(1)
glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST)
glEnable(GL_TEXTURE_2D)
glBlendFunc(GL_SRC_ALPHA, GL_ONE)
glEnable(GL_BLEND)
for i = 1, num_stars do
  stars[i] = { angle = 0, dist = i/num_stars*5,
    r = math.random(), g = math.random(), b = math.random() }
end

my_texture = glGenTextures(1)
glBindTexture(GL_TEXTURE_2D, my_texture)
glTexParameter(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR)
glTexParameter(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR)
loadImage('test/nehe/star.bmp'):glTexImage2D()

NeheLoop:new():run()
