
require 'extlib'
require 'globalgl'
require 'Event'
require 'MainLoop'

function toggle(enabling)
  return enabling and glEnable or glDisable
end

-- the GL app itself may overwrite these functions and settings
WIDTH = 640
HEIGHT = 480
FULLSCREEN = false
function handleKeypress(sym)
end
function computeFrame()
end
function drawGLScene(interpolation)
end

NeheLoop = MainLoop:instantiate()

function NeheLoop:key(ev)
  if not ev.down then return end
  if ev.sym == SDL.K_ESCAPE then self:quit() end
  if ev.sym == SDL.K_F1 then pcall(SDL.WM_ToggleFullScreen); return end
  handleKeypress(ev.sym)
end
function NeheLoop:update()
  computeFrame()
end
function NeheLoop:display()
  drawGLScene(self.frameFraction)
end

function loadImage(fn)
  local rw = FS.load(fn); local img = SDL.IMG_Load_RW(rw, true); rw:disown()
  return img
end

function initScreen(w, h, f)
  SDL.GL_SetAttribute(SDL.GL_DOUBLEBUFFER, 1)
  SDL.GL_SetAttribute(SDL.GL_ALPHA_SIZE, 1)
  SDL.SetVideoMode(WIDTH, HEIGHT, FULLSCREEN)
  glViewport(0, 0, WIDTH, HEIGHT)
  glMatrixMode(GL_PROJECTION); glLoadIdentity()
  gluPerspective(45.0, WIDTH/HEIGHT, 0.1, 100.0)
  glMatrixMode(GL_MODELVIEW); glLoadIdentity()
end
