
require 'test.nehe.nehelib'

xrot, yrot, zrot = 0, 0, 0
my_texture = nil

function drawGLScene(interpolation)
  glClear(GL_COLOR_BUFFER_BIT + GL_DEPTH_BUFFER_BIT)
  
  glMatrixMode(GL_PROJECTION); glLoadIdentity()
  gluPerspective(45.0, 640/480, 0.1, 100.0)
  glMatrixMode(GL_MODELVIEW); glLoadIdentity()
  
  glTranslate(0, 0, -5)
  glRotate(xrot + (interpolation * 0.3), 1, 0, 0)
  glRotate(yrot + (interpolation * 0.2), 0, 1, 0)
  glRotate(zrot + (interpolation * 0.4), 0, 0, 1)
  
  glBindTexture(GL_TEXTURE_2D, my_texture)
  
  glBegin(GL_QUADS)
    glTexCoord(1, 1); glVertex( 1,  1, -1)
    glTexCoord(0, 1); glVertex(-1,  1, -1)
    glTexCoord(0, 0); glVertex(-1,  1,  1)
    glTexCoord(1, 0); glVertex( 1,  1,  1)
    
    glTexCoord(0, 0); glVertex( 1, -1,  1)
    glTexCoord(1, 0); glVertex(-1, -1,  1)
    glTexCoord(1, 1); glVertex(-1, -1, -1)
    glTexCoord(0, 1); glVertex( 1, -1, -1)
    
    glTexCoord(1, 1); glVertex( 1,  1,  1)
    glTexCoord(0, 1); glVertex(-1,  1,  1)
    glTexCoord(0, 0); glVertex(-1, -1,  1)
    glTexCoord(1, 0); glVertex( 1, -1,  1)
    
    glTexCoord(1, 1); glVertex(-1,  1, -1)
    glTexCoord(0, 1); glVertex( 1,  1, -1)
    glTexCoord(0, 0); glVertex( 1, -1, -1)
    glTexCoord(1, 0); glVertex(-1, -1, -1)
    
    glTexCoord(1, 1); glVertex(-1,  1,  1)
    glTexCoord(0, 1); glVertex(-1,  1, -1)
    glTexCoord(0, 0); glVertex(-1, -1, -1)
    glTexCoord(1, 0); glVertex(-1, -1,  1)
    
    glTexCoord(1, 1); glVertex( 1,  1, -1)
    glTexCoord(0, 1); glVertex( 1,  1,  1)
    glTexCoord(0, 0); glVertex( 1, -1,  1)
    glTexCoord(1, 0); glVertex( 1, -1, -1)
  glEnd()
  
  glMatrixMode(GL_PROJECTION); glLoadIdentity()
  glOrtho(0, 4, 0, 3, -1, 1)
  glMatrixMode(GL_MODELVIEW); glLoadIdentity()
  glBegin(GL_TRIANGLES) glVertex(1, 0, 0) glVertex(2, 1, 0) glVertex(3, 0, 0) glEnd()
end

function computeFrame()
  xrot = xrot + 0.3
  yrot = yrot + 0.2
  zrot = zrot + 0.4
end

initScreen()

glShadeModel(GL_SMOOTH)
glClearColor(0, 0, 0, 0)
glClearDepth(1)
glEnable(GL_DEPTH_TEST)
glDepthFunc(GL_LEQUAL)
glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST)
glEnable(GL_TEXTURE_2D)

my_texture = glGenTextures(1)
glBindTexture(GL_TEXTURE_2D, my_texture)
loadImage('test/nehe/nehe.bmp'):glTexImage2D()
glTexParameter(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR)
glTexParameter(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR)

NeheLoop:new():run()
