
require 'generate'

function write_output_lgllib()
  check_funcs = {
    GLenum = 'checkenum(L, @n)',
    GLbitfield = 'luaL_checkinteger(L, @n)',
    GLboolean = 'checkboolean(L, @n)',
    GLbyte = 'luaL_checkinteger(L, @n)',
    GLubyte = 'luaL_checkinteger(L, @n)',
    GLshort = 'luaL_checkinteger(L, @n)',
    GLushort = 'luaL_checkinteger(L, @n)',
    GLint = 'luaL_checkinteger(L, @n)',
    GLuint = 'luaL_checkinteger(L, @n)',
    GLsizei = 'luaL_checkinteger(L, @n)',
    GLfloat = 'luaL_checknumber(L, @n)',
    GLclampf = 'luaL_checknumber(L, @n)',
    GLdouble = 'luaL_checknumber(L, @n)',
    GLclampd = 'luaL_checknumber(L, @n)',
    ['const GLubyte*'] = '(const GLubyte *)luaL_checkstring(L, @n)',
    ['GLUnurbs*'] = '*((GLUnurbs **) luaL_checkudata(L, @n, "GLUnurbs"))',
    ['GLUquadric*'] = '*((GLUquadric **) luaL_checkudata(L, @n, "GLUquadric"))',
    ['GLUtesselator*'] = '*((GLUtesselator **) luaL_checkudata(L, @n, "GLUtesselator"))',
  }
  
  return_codes = {
    GLenum = 'lua_pushinteger(L, @b);',
    GLbitfield = 'lua_pushinteger(L, @b);',
    GLboolean = 'lua_pushboolean(L, @b);',
    GLbyte = 'lua_pushinteger(L, @b);',
    GLubyte = 'lua_pushinteger(L, @b);',
    GLshort = 'lua_pushinteger(L, @b);',
    GLushort = 'lua_pushinteger(L, @b);',
    GLint = 'lua_pushinteger(L, @b);',
    GLuint = 'lua_pushinteger(L, @b);',
    GLsizei = 'lua_pushinteger(L, @b);',
    GLfloat = 'lua_pushnumber(L, @b);',
    GLclampf = 'lua_pushnumber(L, @b);',
    GLdouble = 'lua_pushnumber(L, @b);',
    GLclampd = 'lua_pushnumber(L, @b);',
    ['const GLubyte*'] = 'lua_pushstring(L, (const char *)@b);',
    void = '@v;',
  }
  
  io.write[[
/* auto-generated by gengl.lua */

#include <string.h>
#include <stdlib.h>

#include <lua.h>
#include <lauxlib.h>

#include <SDL_opengl.h>

#include "glproto.h"

/* from lsdllib.c */
const void* check_const_ptr(lua_State *L, int narg);
void* check_ptr(lua_State *L, int narg);

GLenum checkenum(lua_State *L, int narg) {
  if(lua_type(L, narg) == LUA_TSTRING) {
    GLenum e;
    lua_getglobal(L, "gl");
    if(!lua_istable(L, -1)) luaL_error(L, "can't find global table gl");
    lua_pushvalue(L, narg);
    lua_gettable(L, -2);
    if(!lua_isnumber(L, -1)) luaL_argerror(L, narg, "invalid GL constant");
    e = lua_tointeger(L, -1);
    lua_pop(L, 2);
    return e;
  }
  return luaL_checkinteger(L, narg);
}

GLboolean checkboolean(lua_State *L, int narg) {
  return lua_isnumber(L, narg) ? (lua_tointeger(L, narg) != GL_FALSE) :
    lua_toboolean(L, narg);
}

]]
  local b = {}; setmetatable(b, { __index = function (_, fn)
    return function (...) io.write(Bind(fn, ...), "\n\n") end
  end })
  b.glClearIndex{}
  b.glClearColor{}
  b.glClear{}
  b.glIndexMask{}
  b.glColorMask{}
  b.glAlphaFunc{}
  b.glBlendFunc{}
  b.glLogicOp{}
  b.glCullFace{}
  b.glFrontFace{}
  b.glPointSize{}
  b.glLineWidth{}
  b.glLineStipple{}
  b.glPolygonMode{}
  b.glPolygonOffset{}
--  glPolygonStipple glGetPolygonStipple   TODO (maybe)
  b.glEdgeFlag{}
--  glEdgeFlagv
  b.glScissor{}
  b.glClipPlane{ Array=4 }
  b.glGetClipPlane{ Returns=4 }
  b.glDrawBuffer{}
  b.glReadBuffer{}
  b.glEnable{}
  b.glDisable{}
  b.glIsEnabled{}
  b.glEnableClientState{}
  b.glDisableClientState{}
  b.glGetBooleanv{ suffix=1, Returns=16 }
  b.glGetDoublev{ suffix=1, Returns=16 }
  b.glGetIntegerv{ suffix=1, Returns=16 }
  b.glPushAttrib{}
  b.glPopAttrib{}
  b.glPushClientAttrib{}
  b.glPopClientAttrib{}
  b.glRenderMode{}
  b.glGetError{}
  b.glGetString{}
  b.glFinish{}
  b.glFlush{}
  b.glHint{}
  b.glClearDepth{}
  b.glDepthFunc{}
  b.glDepthMask{}
  b.glDepthRange{}
  b.glClearAccum{}
  b.glAccum{}
  b.glMatrixMode{}
  b.glOrtho{}
  b.glFrustum{}
  b.glViewport{}
  b.glPushMatrix{}
  b.glPopMatrix{}
  b.glLoadIdentity{}
  b.glLoadMatrixd{ suffix=1, Array=16 }
--  glLoadMatrixf
  b.glMultMatrixd{ suffix=1, Array=16 }
--  glMultMatrixf
  b.glRotated{ suffix=1 }
--  glRotatef
  b.glScaled{ suffix=1 }
--  glScalef
  b.glTranslated{ suffix=1 }
--  glTranslatef
  b.glIsList{}
  b.glDeleteLists{}
  b.glGenLists{}
  b.glNewList{}
  b.glEndList{}
  b.glCallList{}
  b.glCallLists{ Buffer=true }
  b.glListBase{}
  b.glBegin{}
  b.glEnd{}
  -- glVertex, glNormal, glIndex, glColor, glTexCoord, glRasterPos,
  -- glRect: only one variant
  b.glVertex4dv{ suffix=3, Array=4, defaults='{ 0, 0, 0, 1 }' }
  b.glNormal3dv{ suffix=3, Array=3 }
  b.glIndexd{ suffix=1 }
  b.glColor4dv{ suffix=3, Array=4, defaults='{ 0, 0, 0, 1 }' }
  b.glColor4ubv{ suffix=1, Array=4, defaults='{ 0, 0, 0, 255 }' }
  b.glTexCoord4dv{ suffix=3, Array=4, defaults='{ 0, 0, 0, 1 }' }
  b.glRasterPos4dv{ suffix=3, Array=4, defaults='{ 0, 0, 0, 1 }' }
  b.glRectd{ suffix=1 }
  b.glVertexPointer{ Buffer=true }
  b.glNormalPointer{ Buffer=true }
  b.glColorPointer{ Buffer=true }
  b.glIndexPointer{ Buffer=true }
  b.glTexCoordPointer{ Buffer=true }
  b.glEdgeFlagPointer{ Buffer=true }
--  glGetPointerv   maybe TODO?
  b.glArrayElement{}
  b.glDrawArrays{}
  b.glDrawElements{ Buffer=true }
  b.glInterleavedArrays{ Buffer=true }
  b.glShadeModel{}
--  glLightf
--  glLighti
  b.glLightfv{ suffix=2, Array=4, defaults=true }
--  glLightiv
  b.glGetLightfv{ suffix=2, Returns=4 }
--  glGetLightiv
--  glLightModelf
--  glLightModeli
  b.glLightModelfv{ suffix=2, Array=4, defaults=true }
--  glLightModeliv
--  glMaterialf
--  glMateriali
  b.glMaterialfv{ suffix=2, Array=4, defaults=true }
--  glMaterialiv
  b.glGetMaterialfv{ suffix=2, Returns=4 }
--  glGetMaterialiv
  b.glColorMaterial{}
  b.glPixelZoom{}
  b.glPixelStoref{ suffix=1 }
--  glPixelStorei
  b.glPixelTransferf{ suffix=1 }
--  glPixelTransferi
  b.glPixelMapfv{ suffix=1, Buffer=true }
  b.glPixelMapuiv{ suffix=1, Buffer=true }
  b.glPixelMapusv{ suffix=1, Buffer=true }
  b.glGetPixelMapfv{ suffix=1, Buffer=true }
  b.glGetPixelMapuiv{ suffix=1, Buffer=true }
  b.glGetPixelMapusv{ suffix=1, Buffer=true }
  b.glBitmap{ Buffer=true }
  b.glReadPixels{ Buffer=true }
  b.glDrawPixels{ Buffer=true }
  b.glCopyPixels{}
  b.glStencilFunc{}
  b.glStencilMask{}
  b.glStencilOp{}
  b.glClearStencil{}
  -- glTexGen, glGetTexGen, glTexEnv, glGetTexEnv, glTexParameter,
  -- glGetTexParameter, glGetTexLevelParameter: only one variant
  b.glTexGendv{ suffix=2, Array=4, defaults=true }
  b.glGetTexGendv{ suffix=2, Returns=4 }
  b.glTexEnvfv{ suffix=2, Array=4, defaults=true }
  b.glGetTexEnvfv{ suffix=2, Returns=4 }
  b.glTexParameterfv{ suffix=2, Array=4, defaults=true }
  b.glGetTexParameterfv{ suffix=2, Returns=4 }
  b.glGetTexLevelParameterfv{ suffix=2, Returns=4 }  -- TODO: does this return 4 results?
  b.glTexImage1D{ Buffer=true }
  b.glTexImage2D{ Buffer=true }
  b.glGetTexImage{ Buffer=true }
  b.glGenTextures{ [1] = { Counter=true }, Returns='c1' }
  b.glDeleteTextures{ [1] = { Counter=true }, Array='c1' }
  b.glBindTexture{}
  b.glPrioritizeTextures{ [1] = { Counter=true }, Array='c1' }
  b.glAreTexturesResident{ [1] = { Counter=true }, [2] = { Array='c1' }, [3] = { Returns='c1' } }
  b.glIsTexture{}
  b.glTexSubImage1D{ Buffer=true }
  b.glTexSubImage2D{ Buffer=true }
  b.glCopyTexImage1D{}
  b.glCopyTexImage2D{}
  b.glCopyTexSubImage1D{}
  b.glCopyTexSubImage2D{}
--  glMap1:d                        maybe TODO
--  glMap1f
--  glMap2:d                        maybe TODO
--  glMap2f
--  glGetMap:dv                     maybe TODO
--  glGetMapfv
--  glGetMapiv
  b.glEvalCoord1d{ suffix=1 }
--  glEvalCoord1f
--  glEvalCoord1dv
--  glEvalCoord1fv
  b.glEvalCoord2d{ suffix=1 }
--  glEvalCoord2f
--  glEvalCoord2dv
--  glEvalCoord2fv
  b.glMapGrid1d{ suffix=1 }
--  glMapGrid1f
  b.glMapGrid2d{ suffix=1 }
--  glMapGrid2f
  b.glEvalPoint1{}
  b.glEvalPoint2{}
  b.glEvalMesh1{}
  b.glEvalMesh2{}
--  glFogf
--  glFogi
  b.glFogfv{ suffix=2, Array=4, defaults=true }
--  glFogiv
  b.glFeedbackBuffer{ Buffer=true }
  b.glPassThrough{}
  b.glSelectBuffer{ Buffer=true }
  b.glInitNames{}
  b.glLoadName{}
  b.glPushName{}
  b.glPopName{}
  --[[ *********************************************
  b.glDrawRangeElements{}
  b.glTexImage3D{}
  b.glTexSubImage3D{}
  b.glCopyTexSubImage3D{}
  b.glColorTable{}
  b.glColorSubTable{}
  b.glColorTableParameteriv{}
  b.glColorTableParameterfv{}
  b.glCopyColorSubTable{}
  b.glCopyColorTable{}
  b.glGetColorTable{}
  b.glGetColorTableParameterfv{}
  b.glGetColorTableParameteriv{}
  b.glBlendEquation{}
  b.glBlendColor{}
  b.glHistogram{}
  b.glResetHistogram{}
  b.glGetHistogram{}
  b.glGetHistogramParameterfv{}
  b.glGetHistogramParameteriv{}
  b.glMinmax{}
  b.glResetMinmax{}
  b.glGetMinmax{}
  b.glGetMinmaxParameterfv{}
  b.glGetMinmaxParameteriv{}
  b.glConvolutionFilter1D{}
  b.glConvolutionFilter2D{}
  b.glConvolutionParameterf{}
  b.glConvolutionParameterfv{}
  b.glConvolutionParameteri{}
  b.glConvolutionParameteriv{}
  b.glCopyConvolutionFilter1D{}
  b.glCopyConvolutionFilter2D{}
  b.glGetConvolutionFilter{}
  b.glGetConvolutionParameterfv{}
  b.glGetConvolutionParameteriv{}
  b.glSeparableFilter2D{}
  b.glGetSeparableFilter{}
  b.glActiveTexture{}
  b.glClientActiveTexture{}
  b.glCompressedTexImage1D{}
  b.glCompressedTexImage2D{}
  b.glCompressedTexImage3D{}
  b.glCompressedTexSubImage1D{}
  b.glCompressedTexSubImage2D{}
  b.glCompressedTexSubImage3D{}
  b.glGetCompressedTexImage{}
  b.glMultiTexCoord1d{}
  b.glMultiTexCoord1dv{}
  b.glMultiTexCoord1f{}
  b.glMultiTexCoord1fv{}
  b.glMultiTexCoord1i{}
  b.glMultiTexCoord1iv{}
  b.glMultiTexCoord1s{}
  b.glMultiTexCoord1sv{}
  b.glMultiTexCoord2d{}
  b.glMultiTexCoord2dv{}
  b.glMultiTexCoord2f{}
  b.glMultiTexCoord2fv{}
  b.glMultiTexCoord2i{}
  b.glMultiTexCoord2iv{}
  b.glMultiTexCoord2s{}
  b.glMultiTexCoord2sv{}
  b.glMultiTexCoord3d{}
  b.glMultiTexCoord3dv{}
  b.glMultiTexCoord3f{}
  b.glMultiTexCoord3fv{}
  b.glMultiTexCoord3i{}
  b.glMultiTexCoord3iv{}
  b.glMultiTexCoord3s{}
  b.glMultiTexCoord3sv{}
  b.glMultiTexCoord4d{}
  b.glMultiTexCoord4dv{}
  b.glMultiTexCoord4f{}
  b.glMultiTexCoord4fv{}
  b.glMultiTexCoord4i{}
  b.glMultiTexCoord4iv{}
  b.glMultiTexCoord4s{}
  b.glMultiTexCoord4sv{}
  b.glLoadTransposeMatrixd{}
  b.glLoadTransposeMatrixf{}
  b.glMultTransposeMatrixd{}
  b.glMultTransposeMatrixf{}
  b.glSampleCoverage{}
  b.glActiveTextureARB{}
  b.glClientActiveTextureARB{}
  b.glMultiTexCoord1dARB{}
  b.glMultiTexCoord1dvARB{}
  b.glMultiTexCoord1fARB{}
  b.glMultiTexCoord1fvARB{}
  b.glMultiTexCoord1iARB{}
  b.glMultiTexCoord1ivARB{}
  b.glMultiTexCoord1sARB{}
  b.glMultiTexCoord1svARB{}
  b.glMultiTexCoord2dARB{}
  b.glMultiTexCoord2dvARB{}
  b.glMultiTexCoord2fARB{}
  b.glMultiTexCoord2fvARB{}
  b.glMultiTexCoord2iARB{}
  b.glMultiTexCoord2ivARB{}
  b.glMultiTexCoord2sARB{}
  b.glMultiTexCoord2svARB{}
  b.glMultiTexCoord3dARB{}
  b.glMultiTexCoord3dvARB{}
  b.glMultiTexCoord3fARB{}
  b.glMultiTexCoord3fvARB{}
  b.glMultiTexCoord3iARB{}
  b.glMultiTexCoord3ivARB{}
  b.glMultiTexCoord3sARB{}
  b.glMultiTexCoord3svARB{}
  b.glMultiTexCoord4dARB{}
  b.glMultiTexCoord4dvARB{}
  b.glMultiTexCoord4fARB{}
  b.glMultiTexCoord4fvARB{}
  b.glMultiTexCoord4iARB{}
  b.glMultiTexCoord4ivARB{}
  b.glMultiTexCoord4sARB{}
  b.glMultiTexCoord4svARB{}
  b.glCreateDebugObjectMESA{}
  b.glClearDebugLogMESA{}
  b.glGetDebugLogMESA{}
  b.glGetDebugLogLengthMESA{}
  b.glProgramCallbackMESA{}
  b.glGetProgramRegisterfvMESA{}
  b.glBlendEquationSeparateATI{}
  ********************************************* ]]
  b.gluBeginCurve{}
  b.gluBeginPolygon{}
  b.gluBeginSurface{}
  b.gluBeginTrim{}
--  gluBuild1DMipmapLevels { Buffer=true }   -- not present in MinGW glu.h
  b.gluBuild1DMipmaps{ Buffer=true }
--  gluBuild2DMipmapLevels { Buffer=true }   -- not present in MinGW glu.h
  b.gluBuild2DMipmaps{ Buffer=true }
--  gluBuild3DMipmapLevels { Buffer=true }   -- not present in MinGW glu.h
--  gluBuild3DMipmaps { Buffer=true }        -- not present in MinGW glu.h
--  gluCheckExtension                        -- not present in MinGW glu.h
  b.gluCylinder{}
  b.gluDeleteNurbsRenderer{}
  b.gluDeleteQuadric{}
  b.gluDeleteTess{}
  b.gluDisk{}
  b.gluEndCurve{}
  b.gluEndPolygon{}
  b.gluEndSurface{}
  b.gluEndTrim{}
  b.gluErrorString{}
  b.gluGetNurbsProperty{ [3] = { Returns=1 } }
  b.gluGetString{}
  b.gluGetTessProperty{ [3] = { Returns=1 } }
  b.gluLoadSamplingMatrices { [2] = { Array=16 }, [3] = { Array=16 }, [4] = { Array=4 } }
  b.gluLookAt{}
  local makeud = [[@T **ud = (@T **)lua_newuserdata(L, sizeof(@T *));
*ud = @b;
if(*ud == NULL) return luaL_error(L, "out of memory");
luaL_getmetatable(L, "@T"); lua_setmetatable(L, -2);]]
  b.gluNewQuadric{ return_code = makeud:gsub('@T', 'GLUquadric') }
  b.gluNewNurbsRenderer{ return_code = makeud:gsub('@T', 'GLUnurbs') }
  b.gluNewTess{ return_code = makeud:gsub('@T', 'GLUtesselator') }
  b.gluNextContour{}
--  gluNurbsCallback       TODO
--  gluNurbsCallbackData
--  gluNurbsCallbackDataEXT
--  gluNurbsCurve          TODO
  b.gluNurbsProperty{}
--  gluNurbsSurface        TODO
  b.gluOrtho2D{}
  b.gluPartialDisk{}
  b.gluPerspective{}
  b.gluPickMatrix{ Array=4 }
  b.gluProject{ [4] = { Array=16 }, [5] = { Array=16 }, [6] = { Array=4 }, [7] = { Returns=1 }, [8] = { Returns=1 }, [9] = { Returns=1 } }
--  gluPwlCurve          TODO
--  gluQuadricCallback       TODO
  b.gluQuadricDrawStyle{}
  b.gluQuadricNormals{}
  b.gluQuadricOrientation{}
  b.gluQuadricTexture{}
  b.gluScaleImage{ Buffer=true }
  b.gluSphere{}
  b.gluTessBeginContour{}
--  gluTessBeginPolygon    TODO
--  gluTessCallback       TODO
  b.gluTessEndContour{}
  b.gluTessEndPolygon{}
  b.gluTessNormal{}
  b.gluTessProperty{}
--  gluTessVertex           TODO
  b.gluUnProject{ [4] = { Array=16 }, [5] = { Array=16 }, [6] = { Array=4 }, [7] = { Returns=1 }, [8] = { Returns=1 }, [9] = { Returns=1 } }
  -- argh! gluUnProject4 isn't present in MinGW libglu32.a
  --b.gluUnProject4{ [5] = { Array=16 }, [6] = { Array=16 }, [7] = { Array=4 }, [10] = { Returns=1 }, [11] = { Returns=1 }, [12] = { Returns=1 }, [13] = { Returns=1 } }
  
  local function regitem(n,v) io.write('    { "', n, '", ', v, ' },\n') end
  io.write[[
int luaopen_gl(lua_State *L) {
  int i;
  const luaL_Reg reg_gl[] = {
]]
  for _,f in ipairs(bindlist) do if not f:match('^glu') then
    regitem(f:sub(3), 'b_'..f)
    if boundinfo[f].suffix then
      regitem(f:sub(3, -1-boundinfo[f].suffix), 'b_'..f) end
  end end
  io.write[[
    { NULL, NULL }
  };
  const luaL_Reg reg_glu[] = {
]]
  for _,f in ipairs(bindlist) do if f:match('^glu') and not f:match('^gluDelete') then
    regitem(f:sub(4), 'b_'..f)
    if boundinfo[f].suffix then
      regitem(f:sub(4, -1-boundinfo[f].suffix), 'b_'..f) end
  end end
  io.write[[
    { NULL, NULL }
  };
  struct {
    const char *name;
    lua_Number value;
  } const_gl[] = {
]]
  for c in Input:gmatch('\n#%s*define%s+GL_[^\n]*') do
    regitem(c:match('GL_([%w_]*)'), c:match('GL_[%w_]* *(.*)'))
  end
  io.write[[
    { NULL, 0 }
  }, const_glu[] = {
]]
  for c in Input:gmatch('\n#%s*define%s+GLU_[^\n]*') do
    regitem(c:match('GLU_([%w_]*)'), c:match('GLU_[%w_]* *(.*)'))
  end
  io.write[[
    { NULL, 0 }
  };
  
  lua_settop(L, 0);
  
  luaL_register(L, "glu", reg_glu);
  lua_pushvalue(L, 1); lua_setglobal(L, "GLU");
  for(i = 0; const_glu[i].name; i++) {
    lua_pushnumber(L, const_glu[i].value);
    lua_setfield(L, 1, const_glu[i].name);
  }
  luaL_newmetatable(L, "GLUtesselator");
  lua_pushvalue(L, 1); lua_setfield(L, -2, "__index");
  lua_pushcfunction(L, b_gluDeleteTess); lua_setfield(L, -2, "__gc");
  luaL_newmetatable(L, "GLUnurbs");
  lua_pushvalue(L, 1); lua_setfield(L, -2, "__index");
  lua_pushcfunction(L, b_gluDeleteNurbsRenderer); lua_setfield(L, -2, "__gc");
  luaL_newmetatable(L, "GLUquadric");
  lua_pushvalue(L, 1); lua_setfield(L, -2, "__index");
  lua_pushcfunction(L, b_gluDeleteQuadric); lua_setfield(L, -2, "__gc");
  lua_settop(L, 0);
  
  luaL_register(L, "gl", reg_gl);
  lua_pushvalue(L, 1); lua_setglobal(L, "GL");
  for(i = 0; const_gl[i].name; i++) {
    lua_pushnumber(L, const_gl[i].value);
    lua_setfield(L, 1, const_gl[i].name);
  }
  
  return 1;
}
]]
end

local include_path = parse_include_path_args(arg)
include_path[#include_path+1] = '/usr/local/include'
include_path[#include_path+1] = '/usr/include'
local SDL_opengl_h, gl_h, glu_h = {}, {}, {}
for _,dir in ipairs(include_path) do
  SDL_opengl_h[#SDL_opengl_h+1] = dir..'/SDL_opengl.h'
  for _,subdir in ipairs({ '/OpenGL/', '/GL/', '/' }) do
    gl_h[#gl_h+1] = dir..subdir..'gl.h'
    glu_h[#glu_h+1] = dir..subdir..'glu.h'
  end
end
parse_headers(assert(try_file_locations(gl_h)) ..
  "\n" .. assert(try_file_locations(glu_h)) ..
  "\n" .. assert(try_file_locations(SDL_opengl_h)))
write_output_lgllib()

