#include <lua.h>
#include <lauxlib.h>

#ifdef _WIN32
#include <shlobj.h>
#endif

int get_appdata(lua_State *L) {
#ifdef _WIN32
  char pbuf[MAX_PATH];
  if(SHGetFolderPath(NULL, CSIDL_APPDATA, NULL, 0, pbuf) == S_OK)
    lua_pushstring(L, pbuf);
  else
    lua_pushnil(L);
#else
  lua_pushnil(L);
#endif
  return 1;
}

int luaopen_win(lua_State *L) {
  const struct luaL_Reg win[] = {
    { "appdata", get_appdata },
    { NULL, NULL }
  };
  luaL_register(L, "win", win);
  return 1;
}

